﻿using System;
using System.Collections.Generic;
using IronPython.Hosting;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            BasicSample();

            CallPythonFuncFromCSharp();

            var scriptEngine = Python.CreateEngine();
            var scriptScope = scriptEngine.CreateScope();

            List<string> list = new List<string>();
            scriptScope.SetVariable("myList", list);

            string code = @"
myList.Add('my')
myList.Add('python')
";
            scriptEngine.Execute(code, scriptScope);

            foreach (var item in list)
            {
                Console.WriteLine(item);
            }
        }

        private static void CallPythonFuncFromCSharp()
        {
            var scriptEngine = Python.CreateEngine();
            var scriptScope = scriptEngine.CreateScope();

            string code = @"
def AddFunc(a, b):
    print 'AddFunc called'
    return (a + b)
";
            scriptEngine.Execute(code, scriptScope);

            dynamic addFunc = scriptScope.GetVariable("AddFunc");
            int nResult = addFunc(5, 10);

            Console.WriteLine(nResult);
        }

        private static void BasicSample()
        {
            var scriptEngine = Python.CreateEngine();

            string code = @"
print 'Hello Python'
";
            scriptEngine.Execute(code);
        }
    }
}
